/* ARKANOID by Deadk */

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libcd.h>
#include <kernel.h>
/* I DONT CARE if all of these are necessary thou */

#include <stdio.h>
#include <string.h>
#include "images.h"


//define konstant for pad kontroll
#define PADLup     (1<<12)
#define PADLdown   (1<<14)
#define PADLleft   (1<<15)
#define PADLright  (1<<13)
#define PADRup     (1<< 4)
#define PADRdown   (1<< 6)
#define PADRleft   (1<< 7)
#define PADRright  (1<< 5)
#define PADi       (1<< 9)
#define PADj       (1<<10)
#define PADk       (1<< 8)
#define PADl       (1<< 3)
#define PADm       (1<< 1)
#define PADn       (1<< 2)
#define PADo       (1<< 0)
#define PADh       (1<<11)
#define PADL1      PADn
#define PADL2      PADo
#define PADR1      PADl
#define PADR2      PADm
#define PADstart   PADh
#define PADselect  PADk


#define OT_LENGTH       14              // OT lenght
#define PACKETMAX       (10000)         // max obj #
#define PACKETMAX2      (PACKETMAX*24)  // (psx voodoo, multiply by 24)
#define SCREEN_WIDTH  320               // width & height skreen
#define SCREEN_HEIGHT 240

GsOT      WorldOrderingTable[2];                // OT handlers
GsOT_TAG  OrderingTable[2][1<<OT_LENGTH];	// OT
PACKET    GPUOutputPacket[2][PACKETMAX2];       // GPU packet work area

static u_long PadData;                                                 
volatile u_char *bb0,*bb1;

GsSPRITE bar, ball, tile[24];           // sprite handler
int dx=1, dy=-1;                         // ball direction
int i;
int od=0;

int InitGraphics(void);                          // init graphiks
int InitSprite (void);                           // init sprites
void RenderView(void);                           // render 
void MoveBar();                                  // move bar :)       
int Kollide(GsSPRITE alfa, GsSPRITE beta);       // kollide detections
int BallBorder();
void theend(int n);

int main(void)
{
   PadInit(0);                  // init pad
   PadData = 0 ;
   if (InitGraphics() == 0) {   // init graphiks
      printf("initgraphics fucking error\n");
      return 0;
   }
   if (InitSprite() == 0) {     // Init sprite structures
      printf("initsprite error\n");
      return 0;
   }

   while ((PadData & PADselect)==0) {          //until u dont hit "selekt"...
      if(Kollide(ball, bar)) dy=-dy;           //collide detections
      for(i=0; i<24; i++) 
              if(Kollide(ball, tile[i])) {
                      dy=-dy;
                      tile[i].w=tile[i].h= 0;  //delete objekt (if any1 know a better way mail me)
                      od++;
                      if (od==24) theend(2);  
              }
      if (BallBorder() != 0) theend(1);

      MoveBar();                        // :)
      RenderView();        	    	// Render
 }

   ResetGraph(3);                  	// Resetta la modalita video
   return 0;
}

// Init video mode & frame buffer
int InitGraphics(void)
{
   SetVideoMode(MODE_PAL);      // video mode PAL

   // Resolution...
   GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsINTER|GsOFSGPU, 1, 0);

   // Set top-left coord of buffers
   GsDefDispBuff(0, 0, 0, SCREEN_HEIGHT);

   // Init OT
   WorldOrderingTable[0].length = OT_LENGTH;
   WorldOrderingTable[1].length = OT_LENGTH;
   WorldOrderingTable[0].org = OrderingTable[0];
   WorldOrderingTable[1].org = OrderingTable[1];
   GsClearOt(0,0,&WorldOrderingTable[0]);
   GsClearOt(0,0,&WorldOrderingTable[1]);

   return 1;
}

// Init sprites
int InitSprite (void)
{
   RECT            rect;                         // RECT Structure
   GsIMAGE         timdata1, timdata2, timdata3; // Tim Graphic info
	
   // TIM file --> RECT         
   GsGetTimInfo ((u_long *)(BAR_ADDR+4),&timdata1);
   GsGetTimInfo ((u_long *)(BALL_ADDR+4),&timdata2);
   GsGetTimInfo ((u_long *)(TILE_ADDR+4),&timdata3);

   // Load images in frame buffer
   rect.x = timdata1.px;   	// Tim start X Coord
   rect.y = timdata1.py;     	// Tim start Y Coord
   rect.w = timdata1.pw;     	// Data width
   rect.h = timdata1.ph;  	// Data height
   LoadImage(&rect, timdata1.pixel);
   rect.x = timdata2.px;     	// Tim start X Coord
   rect.y = timdata2.py;    	// Tim start Y Coord
   rect.w = timdata2.pw;    	// Data width
   rect.h = timdata2.ph;   	// Data height
   LoadImage(&rect, timdata2.pixel);       
   rect.x = timdata3.px;     	// Tim start X Coord
   rect.y = timdata3.py;    	// Tim start Y Coord
   rect.w = timdata3.pw;    	// Data width
   rect.h = timdata3.ph;   	// Data height
   LoadImage(&rect, timdata3.pixel);       

   //----init sprites
   bar.attribute = 0x02000000;        // 16 Bit Direct, all options off
   bar.x = 150;                       // top left point display position
   bar.y = 220;         
   bar.w = timdata1.pw;               // sprite weight
   bar.h = timdata1.ph;               // sprite height
   bar.tpage = GetTPage(1,0, timdata1.px, timdata1.py); 
   bar.u = 0;                 // position within timfile for sprite
   bar.v = 0;
   bar.r = 128;               // RGB Data
   bar.g = 128;
   bar.b = 128;
   bar.mx = 0;                // x rotation
   bar.my = 0;                // y rotation 
   bar.scalex = ONE;          // Scale values
   bar.scaley = ONE;          
   bar.rotate = 0;            // rotation angle (4096 = 1 degree)

   ball.attribute = 0x02000000;  
   ball.x = 200; 
   ball.y = 120; 
   ball.w = timdata2.pw; 
   ball.h = timdata2.ph;
   ball.tpage = GetTPage(1,0, timdata2.px, timdata2.py); 
   ball.u = 0; 
   ball.v = 0;
   ball.r = 128; 
   ball.g = 128;
   ball.b = 128;
   ball.mx = 0; 
   ball.my = 0; 
   ball.scalex = ONE;
   ball.scaley = ONE; 
   ball.rotate = 0;

 for(i=0; i<24;i++) {  
   tile[i].attribute = 0x02000000;  
   tile[i].x = 5+(i%8)*40; 
   tile[i].y = 5+(i/8)*25; 
   tile[i].w = timdata3.pw; 
   tile[i].h = timdata3.ph;
   tile[i].tpage = GetTPage(1,0, timdata3.px, timdata3.py); 
   tile[i].u = 0; 
   tile[i].v = 0;
   if (i<8) {
     tile[i].r = 59; 
     tile[i].g = 252;
     tile[i].b = 0;
   }
   else if (i<16) {
     tile[i].r = 246; 
     tile[i].g = 254;
     tile[i].b = 1;
   }
   else {
     tile[i].r = 254; 
     tile[i].g = 0;
     tile[i].b = 18;
   }
   tile[i].mx = 0; 
   tile[i].my = 0; 
   tile[i].scalex = ONE;
   tile[i].scaley = ONE; 
   tile[i].rotate = 0;
}

   // wait for all drawing to terminate
   DrawSync(0);

   return 1;
}

int BallBorder() {
      if (ball.x>305) dx=-1;
      else if (ball.x<5) dx=1;
      ball.x=ball.x+5*dx;
      if (ball.y>225) return 1;              
      if (ball.y<5) dy=1;
      ball.y=ball.y+5*dy;
      return 0;
}

void RenderView(void)
{
   int CurrentBuffer;                   // double buffer holder

   CurrentBuffer=GsGetActiveBuff();     // active buffer

   // Setup the packet workbase
   GsSetWorkBase((PACKET*)GPUOutputPacket[CurrentBuffer]);

   // Klear Skreen --> OT
   GsClearOt(0,0,&WorldOrderingTable[CurrentBuffer]);

   // register a sprite in the OT
   GsSortSprite(&ball, &WorldOrderingTable[CurrentBuffer], 0);
   GsSortSprite(&bar, &WorldOrderingTable[CurrentBuffer], 1);
   for(i=0;i<24;i++)  
        GsSortSprite(&tile[i], &WorldOrderingTable[CurrentBuffer], 1);

   DrawSync(0);

   //read pad
   PadData = PadRead(1);  

   // waits for the next vertical blank
   VSync(0);

   // Swap the buffers
   GsSwapDispBuff();

   // Klear Skreen --> OT (with background kolor)
   GsSortClear(0,0,0,&WorldOrderingTable[CurrentBuffer]);

   // drawing for a drawing command allocated to OT
   GsDrawOt(&WorldOrderingTable[CurrentBuffer]);
}

void MoveBar()
{
        if((PadData & PADLright)>0) bar.x +=5;
        if((PadData & PADLleft)>0) bar.x -=5;
        if (bar.x<0) bar.x=0;
        if (bar.x>260) bar.x=260;
}

//kollision detections
/******ive made it in an original way (i thik ;])******/
int Kollide(GsSPRITE alfa, GsSPRITE beta) {
int x[4]; char lx[5];
	int y[4]; char ly[5];
	int i=0 ,j=1;
	int temp; char tempa;

	x[0] = alfa.x;		lx[0] = 'a';
	x[1] = x[0] + alfa.w;	lx[1] = 'b';
	x[2] = beta.x;		lx[2] = 'c';
	x[3] = x[2] + beta.w;	lx[3] = 'd';
	y[0] = alfa.y;		ly[0] = 'z';
	y[1] = y[0] + alfa.h;	ly[1] = 't';
	y[2] = beta.y;		ly[2] = 'x';
	y[3] = y[2] + beta.h;	ly[3] = 'y';

	lx[4]=ly[4]='\0';

	while(i<3) {
		while(j<4) {
			if(x[j]<x[i]) {
				temp=x[i];	tempa=lx[i];
				x[i]=x[j];	lx[i]=lx[j];
				x[j]=temp;	lx[j]=tempa;
			} 
			j++;
		}
		i++; j=i+1;
	}

        i=0; j=1;
	while(i<3) {
		while(j<4) {
			if(y[j]<y[i]) {
				temp=y[i];	tempa=ly[i];
				y[i]=y[j];	ly[i]=ly[j];
				y[j]=temp;	ly[j]=tempa;
			} 
			j++;
		}
		i++; j=i+1;
	}
	
        if ((!strcmp(lx,"acbd")) && (!strcmp(ly,"xzyt"))) return 1;
        if ((!strcmp(lx,"acbd")) && (!strcmp(ly,"zxty"))) return 1;
        if ((!strcmp(lx,"acbd")) && (!strcmp(ly,"zxyt"))) return 1;
        if ((!strcmp(lx,"cabd")) && (!strcmp(ly,"zxty"))) return 1;
        if ((!strcmp(lx,"cabd")) && (!strcmp(ly,"xzyt"))) return 1;
        if ((!strcmp(lx,"cabd")) && (!strcmp(ly,"zxyt"))) return 1;
        if ((!strcmp(lx,"cadb")) && (!strcmp(ly,"xzyt"))) return 1;
        if ((!strcmp(lx,"cadb")) && (!strcmp(ly,"zxty"))) return 1;
        if ((!strcmp(lx,"cadb")) && (!strcmp(ly,"zxyt"))) return 1;
        else return 0;
}

void theend(int n) {
  RECT            rect;                         // RECT Structure
  GsIMAGE         end1;                         // Tim Graphic info
  GsSPRITE        end;
  int CurrentBuffer;                            // double buffer holder

  GsClearOt(0,0,&WorldOrderingTable[0]);
  GsClearOt(0,0,&WorldOrderingTable[1]);

  // TIM file --> RECT
  if (n==1) GsGetTimInfo ((u_long *)(END1_ADDR+4),&end1);
  else GsGetTimInfo ((u_long *)(END2_ADDR+4),&end1);

  // Load images in frame buffer
  rect.x = end1.px;        // Tim start X Coord
  rect.y = end1.py;        // Tim start Y Coord
  rect.w = end1.pw;        // Data width
  rect.h = end1.ph;        // Data height
  LoadImage(&rect, end1.pixel);

  //----init sprites
  end.attribute = 0x02000000;        // 16 Bit Direct, all options off
  end.x = 0;                         // top left point display position
  end.y = 0;         
  end.w = end1.pw;                   // sprite weight
  end.h = end1.ph;                   // sprite height
  end.tpage = GetTPage(1,0, end1.px, end1.py); 
  end.u = 0;                 // position within timfile for sprite
  end.v = 0;
  end.r = 128;               // RGB Data
  end.g = 128;
  end.b = 128;
  end.mx = 0;                // x rotation
  end.my = 0;                // y rotation 
  end.scalex = ONE;          // Scale values
  end.scaley = ONE;          
  end.rotate = 0;            // rotation angle (4096 = 1 degree)

while(1) {
  CurrentBuffer=GsGetActiveBuff();     // active buffer

  // Setup the packet workbase
  GsSetWorkBase((PACKET*)GPUOutputPacket[CurrentBuffer]);

  // Klear Skreen --> OT
  GsClearOt(0,0,&WorldOrderingTable[CurrentBuffer]);

  // register a sprite in the OT
  GsSortSprite(&end, &WorldOrderingTable[CurrentBuffer], 0);

  DrawSync(0);

  // waits for the next vertical blank
  VSync(0);

  // Swap the buffers
  GsSwapDispBuff();

  // Klear Skreen --> OT (with background kolor)
  GsSortClear(0,0,0,&WorldOrderingTable[CurrentBuffer]);

  // drawing for a drawing command allocated to OT
  GsDrawOt(&WorldOrderingTable[CurrentBuffer]);
}

  ResetGraph(3);                       // Resetta la modalita video
  exit(0);
}
